// hard coded, not sure if i have an easier way to do it...
const CART_TYPES = [111177, 111171, 112279];
const WEIRD_TYPE = [ /* Mens Night */ 111881, 112278, 112276, 112279, /* Ladies night */ 112287, 112295, 112294];

const retail = /^https:\/\/(www\.)?us\.merchantos\.com\/register\.php\?form_name=do_payments$/;
const teesheet = /^https:\/\/(www\.)?chronogolf\.(ca|com)\/admin.+\/teesheets$/;

const sleep = (mili) => new Promise((resolve) => setTimeout(() => resolve(), mili));

chrome.runtime.onMessage.addListener(() => {
    const url = window.location.toString();

    const ts = teesheet.exec(url);

    if (retail.test(url)) {
        handleAccount();
    }
    else if (ts != null) {
        handleTeesheet(ts[2]);
    }
});

async function handleTeesheet(tld) {
    let cover = document.querySelector(".app-cover");

    while (cover != null) {
        cover = document.querySelector(".app-cover");
        await sleep(50);
    }

    /**
     * @type {HTMLElement}
    */
    let btnCpy = null;
    let btn = document.querySelector("[ng-click=\"vm.printTeesheet()\"]");

    btnCpy = btn.cloneNode(true);
    btnCpy.addEventListener("click", handlePrint2.bind(null, tld));
    btnCpy.textContent = " Print Alternative Tee Sheets ";

    btn.parentElement.insertBefore(btnCpy, btn.nextSibling);
}

async function handleAccount() {
    let cover = document.querySelector(".app-cover");

    while (cover != null) {
        cover = document.querySelector(".app-cover");
        await sleep(50);
    }


    let owed = { e: document.getElementById("creditAccountBalanceOwedValue"), sign: '-' };

    if (owed.e == null) {
        owed.e = document.getElementById("creditAccountDepositValue");
        owed.sign = '+';
    }

    owed.e.textContent = owed.sign + ' ' + owed.e.textContent;
}

async function handlePrint2(tld) {
    const compareTeeTime = (a, b) => {
        if (typeof (a) === "string") {
            a = { teetime: a }
        }

        if (typeof (b) === "string") {
            b = { teetime: b }
        }

        const [ha, ma] = a.teetime.split(':').map(o => parseInt(o, 10));
        const [hb, mb] = b.teetime.split(':').map(o => parseInt(o, 10));

        const h_diff = ha - hb;

        if (h_diff === 0) {
            return ma - mb;
        }
        return h_diff;
    }

    const isObjectEmpty = (obj) => {
        for (let _ in (obj ?? {})) { return false; }
        return true;
    }

    const createNameFromCustomer = (a) => {
        let obj = a.customer ?? (isObjectEmpty(a.guest) ? { first_name: "Invité" } : a.guest);
        return (obj.first_name == null ? "" : obj.first_name) + (obj.last_name == null ? "" : ` ${obj.last_name}`);
    }

    const getBagStr = (a) => a?.bag_number ?? "";

    const fetchCourseId = async (club_id) => {
        const res = await fetch(`https://www.chronogolf.${tld}/private_api/organizations/${club_id}/courses`);

        if (res.ok) {
            const data = await res.json();
            return data[0].id;
        }

        throw new Error("club error");
    };

    const getTournament = async (club_id, course_id, day) => {
        const day_str = day.toLocaleString("fr-CA", { year: "numeric", month: "numeric", day: "numeric" });

        const res = await fetch(`https://www.chronogolf.${tld}/private_api/events/tournaments?club_id=${club_id}&course_id=${course_id}&date=${day_str}&on=${day_str}`);

        if (!res.ok) {
            throw new Error("teesheet error");
        }

        const data = await res.json();
        const ls = {};

        for (const t of data) {
            let res2 = await fetch(`https://www.chronogolf.${tld}/private_api/events/${t.id}/teetimes`);

            if (res2.ok) {
                if (ls[t.id] == null) {
                    ls[t.id] = {
                        start_time: t.start_time,
                        end_time: t.end_time,
                        name: t.name
                    }
                }
                ls[t.id].teesheets = await res2.json();

                res2 = await fetch(`https://www.chronogolf.${tld}/private_api/events/${t.id}/reservations`);

                if (res2.ok) {
                    if (ls[t.id] != null) {
                        ls[t.id].reservations = await res2.json();
                    }
                }
            }
        }

        return ls
    }
    const getTeesheet = async (course_id, day) => {
        const day_str = day.toLocaleString("fr-CA", { year: "numeric", month: "numeric", day: "numeric" });

        const res = await fetch(`https://www.chronogolf.${tld}/private_api/teesheets?course_id=${course_id}&date=${day_str}&on=${day_str}`);

        if (res.ok) {
            return await res.json();
        }

        throw new Error("teesheet error");
    }

    const getReservation = async (course_id, day) => {
        const day_str = day.toLocaleString("fr-CA", { year: "numeric", month: "numeric", day: "numeric" });

        const res = await fetch(`https://www.chronogolf.${tld}/private_api/reservations?course_id=${course_id}&date=${day_str}&on=${day_str}`);

        if (res.ok) {
            return await res.json();
        }

        throw new Error("teesheet error");
    }

    // If the selected date is not in the week, the day before 'today' is chosen (offset == -1)
    const getSelectedDate = () => {
        const weekpicker = document.querySelector("teesheet-weekpicker");
        const offset = [...weekpicker.children].findIndex((e) => e.classList.contains("is-active"));

        const dt = new Date();

        dt.setDate(dt.getDate() + offset);

        return dt;
    }

    const dt = getSelectedDate();

    const w = window.open("about:blank", "_printable");
    w.document.body.style.fontFamily = "Arial, sans-serif";
    w.document.body.style.color = "#232323";
    w.document.body.textContent = "Loading...";

    const splitted_hash = location.hash.split('/');
    const clubs_location = splitted_hash.findIndex(e => e === "clubs");
    const club_id = splitted_hash[clubs_location + 1];

    const course_id = await fetchCourseId(club_id);

    const result = {};

    const ts = await getTeesheet(course_id, dt);
    const re = await getReservation(course_id, dt);
    const tour = await getTournament(club_id, course_id, dt);

    for (const ttime of ts) {
        if (result[ttime.id] == null) {
            result[ttime.id] = {
                "teetime": ttime.start_time,
                "hole": ttime.hole,
                "players": [],
            }
        }

        for (const reserv of re.filter(r => r.teetime_id === ttime.id)) {
            for (const rou of reserv.rounds) {
                result[ttime.id].players.push(
                    {
                        "nbr": getBagStr(rou.customer),
                        "name": createNameFromCustomer(rou),
                        "is_cart": CART_TYPES.includes(rou.affiliation_type_id),
                        "is_weird": WEIRD_TYPE.includes(rou.affiliation_type_id)
                    }
                )
            }
        }
    }


    for (const ev of Object.values(tour)) {
        for (const ttime of ev.teesheets) {
            if (result[ttime.id] == null) {
                result[ttime.id] = {
                    "teetime": ttime.start_time,
                    "hole": ttime.hole,
                    "players": [],
                }
            }

            for (const reserv of ev.reservations.filter(r => r.teetime_id === ttime.id)) {
                for (const rou of reserv.rounds) {
                    result[ttime.id].players.push(
                        {
                            "nbr": getBagStr(rou.customer),
                            "name": createNameFromCustomer(rou),
                            "is_cart": CART_TYPES.includes(rou.affiliation_type_id),
                            "is_weird": WEIRD_TYPE.includes(rou.affiliation_type_id)
                        }
                    )
                }
            }
        }
    }

    const table = document.createElement("table");
    table.setAttribute("style", "width: 100%; border: 1px solid #23232355; border-collapse: collapse;");

    const head_r = document.createElement("tr");
    head_r.setAttribute("style", "border: 1px solid #23232355;");

    table.appendChild(head_r);

    const sortedResult = Object.values(result).sort(compareTeeTime);

    let isRowShade = false;
    let ev_start = null, ev_end = null;
    let headerShown = false;
    let weirdEvent = false;

    const isCrossOver = sortedResult.some(r => r.hole !== sortedResult[0].hole);

    for (let j = 0; j < sortedResult.length; j++) {
        const ttime = sortedResult[j];

        let row = document.createElement("tr");
        row.setAttribute("style", "border: 1px solid #23232355;-webkit-print-color-adjust: exact;");

        if (isRowShade) {
            row.style.backgroundColor = "#DADADA55"
        }

        isRowShade = !isRowShade;

        if (ev_start == null) {
            // Prévient si le premier départ de la journée est dans le tournoi
            const lastTtime = sortedResult[j - 1] || { teetime: "01:00" };

            // Si l'ancien ttime est avant le tournoi et que celui présent est après le start_time, ou end_time
            ev_start = Object.values(tour).find(t => (
                compareTeeTime(t.start_time, lastTtime.teetime) > 0 &&
                (compareTeeTime(t.end_time, ttime.teetime) < 0 ||
                    compareTeeTime(t.start_time, ttime.teetime) <= 0)
            ));

            weirdEvent = !!ev_start && compareTeeTime(ev_start.end_time, ttime.teetime) < 0;
        }

        if (ev_start != null || weirdEvent) {
            const nextTtime = sortedResult[j + 1];

            if (!weirdEvent && compareTeeTime(nextTtime?.teetime || "19:00", ev_start.end_time) > 0) {
                ev_end = ev_start;
            }

            if (weirdEvent &&
                (nextTtime?.players.length > 0 &&
                    nextTtime?.players.every(p => !p.is_weird)) ||
                compareTeeTime("17:00", nextTtime.teetime) < 0
            ) {
                ev_end = ev_start;
            }

            if (!headerShown) {
                headerShown = true;

                let blank = document.createElement("td");
                blank.setAttribute("style", "border-top: 2px solid #232323; border-left: 2px solid #232323;");
                row.appendChild(blank);

                if (isCrossOver) {
                    blank = document.createElement("td");
                    blank.setAttribute("style", "border-top: 2px solid #232323;");
                    row.appendChild(blank);
                }

                const title = document.createElement("td");
                title.setAttribute("style", "text-align: center; padding: .5rem; border-top: 2px solid #232323; border-right: 2px solid #232323;");
                title.textContent = ev_start.name;
                title.colSpan = 4;
                row.appendChild(title);

                table.appendChild(row);

                row = document.createElement("tr");
                row.setAttribute("style", "border: 1px solid #23232355;-webkit-print-color-adjust: exact;");

                if (isRowShade) {
                    row.style.backgroundColor = "#DADADA55"
                }

                isRowShade = !isRowShade;
            }
        }

        const time = document.createElement("td");

        if (ev_start != null) {
            time.style.borderLeft = "2px solid #232323";
        }

        if (ev_end != null) {
            time.style.borderBottom = "2px solid #232323";
        }

        time.style.textAlign = "center";
        time.textContent = ttime.teetime;
        row.appendChild(time);

        if (isCrossOver) {
            const hole = document.createElement("td");
            hole.style.textAlign = "center";
            hole.style.borderLeft = "1px solid #23232355";
            hole.textContent = ttime.hole;

            if (ev_end != null) {
                hole.style.borderBottom = "2px solid #232323";
            }

            row.appendChild(hole);
        }

        let player_i = 0;

        for (const p of ttime.players) {
            const data = document.createElement("td");
            const wrap = document.createElement("div");
            wrap.setAttribute("style", "display: grid; grid-template-columns: 1fr auto; align-items: center");

            const name = document.createElement("span");
            name.textContent = p.name;

            if (p.is_cart) {
                name.style.fontWeight = "bold";
            }

            wrap.appendChild(name);

            const nbr = document.createElement("span");
            nbr.textContent = p.nbr;

            if (p.is_cart) {
                nbr.style.fontWeight = "bold";
            }
            wrap.appendChild(nbr);


            data.appendChild(wrap);
            data.setAttribute("style", "border: 1px solid #23232355; padding: .5rem");

            if (ev_start && player_i++ === 3) {
                data.style.borderRight = "2px solid #232323";
            }

            if (ev_end != null) {
                data.style.borderBottom = "2px solid #232323";
            }

            row.appendChild(data);
        }

        if (ttime.players.length < 4) {
            for (let i = ttime.players.length; i < 4; i++) {
                const player = document.createElement("td");
                player.setAttribute("style", "border: 1px solid #23232355; padding: .5rem");

                if (ev_start && player_i++ === 3) {
                    player.style.borderRight = "2px solid #232323";
                }

                if (ev_end != null) {
                    player.style.borderBottom = "2px solid #232323";
                }

                row.appendChild(player);
            }
        }

        table.appendChild(row);

        if (ev_end != null) {
            ev_start = null;
            ev_end = null;
            headerShown = false;
            weirdEvent = false;
        }
    }

    const title = document.createElement("h1");
    title.textContent = dt.toLocaleDateString("fr-CA", { weekday: "long", year: "numeric", month: "long", day: "numeric" }).toUpperCase();
    title.style.textAlign = "center";

    w.document.body.textContent = "";
    w.document.body.appendChild(title);
    w.document.body.appendChild(table);

    w.document.close();

    w.document.onload = () => {
        // IE 10+ Compatibility, or something like that 😒
        w.focus();
    }

    queueMicrotask(() => {
        w.print();
    });
}